package grupocars;


/**
 *
 * @author tymos
 * Esta es una clase base para desarrollar en clase comportamiento
 * que trate con un grupo de caracteres. (Dos caracteres por ahora)
 */

public class GrupoCaracteres {
    private Caracter carAnt, carAct;
    private int contCar;    //  Contador de caracteres
    private int contVCont;   //  Contador de vocales contiguas
    public GrupoCaracteres(){
        carAnt = new Caracter();
        carAct = new Caracter();
    }

    public void demo()throws java.io.IOException{
        System.out.println("Tipee caracteres, fin '#'");
        while(carAct.lecCar()){    //  Mientras leamos caracteres ...
            contCar++;
            
            /*
             *  Contamos vocales contiguas
             *  podría hacerse de esta manera:
             *  if(carAct.esVocal() && carAnt.esVocal()) contVCont++;
             * 
             *  Pero en una correcta orientación objetos esto se hace:
             */

            if(vocalesContiguas()) contVCont++;

            /*
             * Debemos instanciar el objeto carAnt a partir de CarAct.
             * Para ello usamos el constructor paramétrico
             */
            carAnt = new Caracter(carAct.getCar());
        }
    }

    public boolean vocalesContiguas(){
        boolean vocCont = false;
        if(carAct.esVocal() && carAnt.esVocal()) vocCont = true;
        return vocCont;
    }
      
    public String toString(){
        String aux = "De los " + contCar+" Caracteres leidos\n";
               aux+= "tenemos    "+contVCont+" vocales contiguas\n";
        return aux;
    }
}
