package linea03;

    /*  Introducir lineas de texto concatenandolas formando un texto
     *  Cada nueva linea va debajo de la anterior
     *  Fin de entrada por linea vacia.
     *
     *  Se pide:
     *  Detectar cuantas veces y en que orden una palabra del texto 
     *  es mas larga que la inmediata anterior. 
     *  El metodo toString debe devolver una cadena conteniendo el texto, y 
     *  lo pedido en el punto anterior.
     *
     *  Para detectar fin de palabra usaremos el concepto de separador:
        Un separador es todo aquello que no sea letra. O sea signos de puntuacin, 
        espacio en blanco, inclusive el '\n'.
        Usaremos un mtodo privado que llamaremos esSeparador que nos devolver 
        verdadero si el caracter es signo o espacio y falso en caso contrario. 
     *
     *  El metodo privado finPalabra() cumplimenta lo pedido por el enunciado 
     *
     */

public class Linea03{ 
    // Atributos private String linea;
    private String texto, posiciones;
    private int cantPal;
    private String separador = " !@I$%&/()=?A[]{}+,;.:\n";

    public Linea03() {  //  Constructor
        texto = "";
        posiciones = "";
    }

    public void cicloLectura(){;
        String linea;
        System.out.println("Lineas, fin con linea vacia");
        while((linea = In.readLine()).length() !=0){
            texto += linea + "\n";  //  concateno
        }
    }

    public void tarea(){ 
        char carAnt = texto.charAt(0);
        char carAct = texto.charAt(0);
        int longAct = 0;    //  longitud de la palabra actual
        int longAnt = 99999;    //  longitud de la palabra anterior
        int orden   = 0;     
        for(int ind = 0; ind < texto.length(); ind++) {
            carAct = texto.charAt(ind);
            if (!esSeparador(carAct))   //  Contamos el caracter
                longAct++;
            if (esSeparador(carAct) && !esSeparador(carAnt)) { 
                // finaliz una palabra 
                orden++;
                finPalabra(longAnt, longAct, orden);
                longAnt = longAct;
                longAct = 0;
            }
            carAnt = carAct;    //  Guardamos para prox. comparacin
        }        
   } // void tarea()
    
    private void finPalabra(int ant, int act, int ord){
        if (act > ant){  // Tenemos una nueva palabra mas larga
            cantPal++;
            posiciones+=" " + ord + ",";
        }
    }
    
    private boolean esSeparador(char car){ 
        boolean signo = false; int ind; char sepa; 
        for(ind = 0; ind < separador.length(); ind++) { 
            sepa = (char)separador.charAt(ind); 
            if (car == sepa) {      // encontro, es signo o espacio
                signo = true; break;
            }
        }            
        return signo;
    }

     public String toString(){ 
        String auxStr ="";
        auxStr = "El texto leido contiene: \n";
        auxStr+= texto+"\n";
        auxStr+= "la cantidad de palabras es: " + cantPal + ",\n";
        auxStr+= "y corresponde a las de orden:\n";
        auxStr+=posiciones;
        return auxStr;
    }
}

